Bug 228865 - Feature Request: Add ipw3945 driver to core or extras
Feature Request: Add ipw3945 driver to core or extras
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: John W. Linville
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2007-02-15 12:01 EST by Keith Outwater
Modified: 2007-11-30 17:11 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-03-23 13:19:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
patch the kernel spec file for d80211 intel modified stack and iwlist driver (1.30 KB, text/x-patch)
2007-02-16 13:00 EST, Nicolas Chauvet (kwizart)
no flags Details
Source file used with the d80211 intel version patch (391 bytes, application/octet-stream)
2007-02-16 13:01 EST, Nicolas Chauvet (kwizart)
no flags Details

  None (edit)
Description Keith Outwater 2007-02-15 12:01:12 EST
Description of problem:
Compaq nw9440 notebook has ipw3945 compatible hardware.  Can the ipw3945 driver
be added to core or extras?  Right now it's a hassle to locate a compatible
driver and keep it up to date.

Version-Release number of selected component (if applicable): N/A

How reproducible: N/A

Steps to Reproduce: N/A

Actual results:
Have to get ipw3945 drivers somewhere else and manually update drivers when
installing a kernel update.

Expected results:
ipw3945 available as part of fedora and updated automatically.

Additional info:
Would be nice to have in FC6 as well.
Comment 1 Radek Vokal 2007-02-16 08:08:39 EST
This package is in review process for RHEL5. What is the status for Fedora?

Spec URL:

SRPM URL: cvs://cvs.devel.redhat.com/cvs/dist?rpms/ipw3945-ucode/RHEL-5

Description: This is the firmware which runs on the ipw3945 device.
Comment 2 Gianluca Sforna 2007-02-16 09:45:03 EST
AFAIK it was not submitted because of the binary only regulatory daemon. 

OTOH livna has it in the review queue
Comment 3 Dennis Gilmore 2007-02-16 10:29:50 EST
now that the binary only daemon is gone.  the new driver should be ok for 
inclusion  but to get into fedora it needs to get in the upstream kernel first
Comment 4 Bill Nottingham 2007-02-16 11:17:17 EST
It will be added when the new iwlwifi driver is in some sort of upstream; it
might be added if it's in the wireless tree, or the netdev tree, as long as it's
on its way to Linus.

Moving from the package review queue to the kernel.
Comment 5 Nicolas Chauvet (kwizart) 2007-02-16 12:48:50 EST
Here is a state of my experimental researches!
Integrating the iwlwifi would need to intégrate the d80211 stack into the kenel
first. As far as i knwo this is planned for 2.6.21 kernel or later... Another
solution would be to make a external kernel module.(kmod)

Since the d80211 isn't already inside the kernel, the version differs from each
drivers...(see #202528 for the rt2x00-kmod ). It would be interesting to have an
experimental version (to be in testing or outside the extras repository for
helping the developers!...)

I've succefully rebuilded a patched kernel with d80211(intel modified) and
iwlwifi (see attachement). I will test if it works with rt2x00 but i would like
to state if that would be best that:
- Until the d80211 isn't in the kernel tree no common version of the d80211 will
appear (it will break kernel.org awaited versionning functionnality!)
- Each driver will bundle its personnal d80211 patched stack

The second part would be to have somewhere a wireless-dev d80211 kernel
(linville already have one - so that's why i've made a intel modified d80211
version) and to test if a common d80211 will work with the more experimental and
updated drivers...
Comment 6 Nicolas Chauvet (kwizart) 2007-02-16 13:00:12 EST
Created attachment 148216 [details]
patch the kernel spec file for d80211 intel modified stack and iwlist driver
Comment 7 Nicolas Chauvet (kwizart) 2007-02-16 13:01:23 EST
Created attachment 148217 [details]
Source file used with the d80211 intel version patch
Comment 8 Nicolas Chauvet (kwizart) 2007-02-16 13:24:53 EST
Iv' took the freedom to cc J. Linville...

rt2x00 d80211 stack discution:

Testing with care d80211 intel modified and iwlwifi driver here:
This is not an offcial kernel maintained by fedora - i'm not a FE maintainer
(not yet - im' searching for a sponsor...). This materiel have been widely
UNTESTED. There would be nicer method to intégrate d80211 and iwlwifi 

http://kwizart.free.fr/blog (french only)
Comment 9 John Guthrie 2007-02-16 23:27:21 EST
Just out of curiosity, how is this d80211 module related to the
ieee80211 kernel module that ipw3945 uses?  
Comment 10 Nicolas Chauvet (kwizart) 2007-02-19 10:10:46 EST
@John Guthrie
The d80211 is not related to the ieee80211 stack...
(ieee80211 can be disabled without problem the new iwlwifi driver only uses
d80211 stack)
iwlwifi: Intel(R) Wirless Link driver for Linux, 0.0.7
iwlwifi: Copyright(c) 2003-2006 Intel Corporation
[root@kwizatz ~]# lsmod |grep iwlwifi
iwlwifi               153641  0 
80211                 238497  1 iwlwifi
[root@kwizatz ~]# lsmod |grep 80211
80211                 238497  1 iwlwifi
ieee80211              43785  0 
ieee80211_crypt        15937  1 ieee80211
[root@kwizatz ~]# rmmod ieee80211
[root@kwizatz ~]# rmmod ieee80211_crypt
[root@kwizatz ~]# lsmod |grep 80211
80211                 238497  1 iwlwifi
Comment 11 Bill Nottingham 2007-03-02 12:32:25 EST
Moving to 'devel' as discussed on
Comment 12 Chi Huynh 2007-03-14 18:16:24 EDT
Sony VGN-FE880E/H has Intel® PRO/Wireless 3945ABG (802.11a/b/g).  Not sure if it
is the same as the wireless network card on Compaq nw9440.  I downloaded the
source code from Intel to build the driver, but it requires ieee 80211 version
1.1.12 or higher to be installed prior to building the ipw3954 driver.  I tried
to build ieee80211 but it requires something else (looks like kernel header
files).  At that point, I gave up.
It would be great to have a rpm file to install the driver for this device.
Comment 13 John W. Linville 2007-03-15 13:26:54 EDT
Please try the test kernels here:


These have the iwlwifi driver built-in.
Comment 14 Roy-Magne Mo 2007-03-17 12:38:03 EDT
Booting kernel-2.6.20-1.2997.fc7 on HP Compaq NX7400 gives me a kernel oops:
wlwifi: Intel(R) Wireless Link driver for Linux, 0.0.11k
iwlwifi: Copyright(c) 2003-2006 Intel Corporation
ACPI: PCI Interrupt 0000:10:00.0[A] -> GSI 17 (level, low) -> IRQ 17
PCI: Setting latency timer of device 0000:10:00.0 to 64
iwlwifi: Detected Intel PRO/Wireless 3945ABG Network Connection
PM: Adding info for No Bus:0000:10:00.0
PM: Removing info for No Bus:0000:10:00.0
iwlwifi: iwlwifi-3945.ucode firmware file req failed: Reason -2
iwlwifi: Could not read microcode from disk: -2
ACPI: PCI interrupt for device 0000:10:00.0 disabled

[ BUG: held lock freed! ]
modprobe/1139 is freeing memory f6b40000-f6b43fff, with a lock still held there!
 (&priv->mutex){--..}, at: [<c061408a>] mutex_lock+0x21/0x24
1 lock held by modprobe/1139:
 #0:  (&priv->mutex){--..}, at: [<c061408a>] mutex_lock+0x21/0x24

stack backtrace:
 [<c04061ed>] show_trace_log_lvl+0x1a/0x2f
 [<c04067b1>] show_trace+0x12/0x14
 [<c0406835>] dump_stack+0x16/0x18
 [<c0441bd5>] debug_check_no_locks_freed+0xe7/0x11a
 [<c04795de>] kfree+0x5a/0xc2
 [<f8a5816a>] cfg80211_dev_free+0x1d/0x20 [cfg80211]
 [<f8a58464>] wiphy_dev_release+0xd/0xf [cfg80211]
 [<c055f7f9>] device_release+0x3c/0x87
 [<c04ef158>] kobject_cleanup+0x46/0x60
 [<c04ef17d>] kobject_release+0xb/0xd
 [<c04efd34>] kref_put+0x75/0x83
 [<c04ef110>] kobject_put+0x14/0x16
 [<c055f99f>] put_device+0x11/0x13
 [<f8a5814b>] wiphy_free+0xb/0xd [cfg80211]
 [<f8ae62c7>] ieee80211_free_hw+0x15/0x18 [mac80211]
 [<f8ba6091>] ipw_pci_probe+0x131a/0x1325 [iwlwifi]
 [<c04fd05d>] pci_device_probe+0x39/0x5b
 [<c0561fa1>] really_probe+0xc7/0x150
 [<c05620bf>] driver_probe_device+0x95/0xa1
 [<c05621e7>] __driver_attach+0x76/0xaf
 [<c0561575>] bus_for_each_dev+0x3a/0x5f
 [<c0561e0b>] driver_attach+0x19/0x1b
 [<c056185c>] bus_add_driver+0x6a/0x170
 [<c056240d>] driver_register+0x79/0x7e
 [<c04fd1db>] __pci_register_driver+0x7c/0xa9
 [<f88fe033>] ipw_init+0x33/0x78 [iwlwifi]
 [<c0449672>] sys_init_module+0x1586/0x16d5
 [<c040507c>] syscall_call+0x7/0xb
iwlwifi: probe of 0000:10:00.0 failed with error -2
Comment 15 John W. Linville 2007-03-23 13:19:28 EDT
Roy-Magne Mo, please see bug 233563.

Since iwlwifi driver is now in rawhide, I'm closing this.

Note You need to log in before you can comment on or make changes to this bug.